/*  load.c

   5 December 2001
   modify from s1 sim 1997, 1998

   add print, printc  to output buffer  31 Dec 2001
   modify to read mspec					14 Feb 2005
   for Sx cpu simulator					11 July 2006
*/

#include "sx.h"
#include <string.h>

//int sclock, uclock;		// system, user, clock
extern int clock;		// sxm.c

extern int status, userp;
extern int intflag;

typedef struct{
	char name[80];
	int ref;
} symentry;

symentry symtab[200];
int numsym;

int CP, DP;		// end of CS, end of loaded DS

void error(char *s){
	printf("error: %s\n",s);
	exit(0);
}

PRIVATE int readM(int *mem, FILE *fi){
	int i, b, e, c;
	fscanf(fi,"%d%d",&b,&e);
	for(i=b; i<=e; i++){
		fscanf(fi,"%d",&c);
		mem[i] = c;
	}
	return e;
}

void loadsym(FILE *fi){
	int i, n, ty, ref, ar, lv;
	char name[80];

	fscanf(fi,"%d",&n);
	i = 1;
	while(i <= n){
		fscanf(fi,"%s%d%d%d%d",&name,&ty,&ref,&ar,&lv);
		strcpy(symtab[i].name,name);
		symtab[i].ref = ref;
		i++;
	}
	numsym = n;
}
/*
void dumpsym(void){
	int i;
	symentry *s;
	printf("%d\n",numsym);
	for(i=1; i<=numsym; i++){
		s = &symtab[i];
		printf("%s %d\n",s->name,s->ref);
	}
}
*/
// return ref of the symbol (s)
int searchsym(char *s){
	int i;
	for(i=1; i<=numsym; i++)
		if(strcmp(s,symtab[i].name) == 0) break;
	return (i > numsym) ? 0 : symtab[i].ref;
}

// return name of ref
char *searchref(int ref){
	int i;
	for(i=1; i<=numsym; i++)
		if(symtab[i].ref == ref) break;
	return (i > numsym) ? 0 : symtab[i].name;
}

// read obj from stdin into memory
void loadobj(char *fn){
	int a;
	FILE *fi;
	fi = fopen(fn,"r");
	if(fi == NULL){
	 printf("input file not found");
	 exit(0);
	}
	fscanf(fi,"%d",&a);
	if( a != OBJ_SOMv2 )
		error("not a som-v2 object");
	a = readM(M,fi);	// code
	CP = a + 1;
	a = readM(M,fi);	 	// string constant, data
	DP = a + 1;
	loadsym(fi);
	fclose(fi);
	printf("load program, last address %d\n",CP);
	printf("DP %d\n",DP);
//	dumpsym();
}
