
/* Sx cpu micro architecture simulator

   5 December 2001
   modify from s2m sim
   Computer Architecture 1997, 1998
   microprogram version 		13 Feb 2005

   sx micro						10 July 2006
   sx0  minimum version			11 July 2006

   P. Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University
*/

#include "sx.h"

#define time_out 10
#define stopped  11
#define blocked  12

extern int status, userp;
extern int intflag;
extern int CP, DP;

/*
void run(void){
	while(runflag) {
//		printf("%d ",PC);
		run3();
		ninst++;
		if(ninst > 1000000) break;
	}
}
*/

void initchip(void){
	clock = 0;
	ninst = 0;
	runflag = 1;
	TS = 0;
	NX = 0;
	FF = 0;
	FP = SSBASE;
	SP = SSBASE;
	PC = 1;
	Z = 0;
	S = 0;
	mpc = 0;
}

PRIVATE void popts(void){
	TS = M[SP];
	SP--;
}

// static alloc memory of size a
PRIVATE int xalloc(int a){
	int b;
	b = DP;
	if( DP + a >= MAXDS )
		error("xalloc: out of memory");
	DP += a;
	return b;
}

PRIVATE void report(void){
  float cpi;
  if( ninst == 0 )
	  printf("0 instruction\n");
  else {
  	  cpi = ((float) clock)/ninst;
  	  printf("%d instructions, %d clocks, CPI %4.2f\n",
	  	ninst,clock,cpi);
  }
}

void trap(int op, int arg){		/* special function */
	int n, a;
	switch(op) {
	case icEnd :
		report();
		status = stopped;
		runflag = 0;
		break;
	case icArray:
		TS = xalloc(TS);
		break;
	case icSys:
		switch(arg){
		case 1: 		// print ts
			printf("%d",TS);
			popts();
	  		break;
		case 2 : 		// printc ts
			printf("%c",TS);
			popts();
	  		break;
		case 13:
			runflag = 0;
			break;
		case 20: intflag = 1; break;
		case 21: intflag = 0; break;
		case 22:
			status = blocked;
            runflag = 0;
			break;
		case 23:
			a = TS;			// pdes
			popts();
            saveCstate(a);
			break;
		case 24:
			a = TS;
			popts();
            restoreCstate(a);   // cause a jump
            intflag = 1;
			break;
		default:
			error("unknown syscall");
		}
		break;
	default:
		error("unknown trap");
	}
}

/*
int main(int argc, char *argv[]){
  if( argc < 2 ) {
    printf("usage : sx objfile\n");
    exit(0);
  }
  loadobj(argv[1]);
  initchip();
  run();
  return 0;
}
*/
